
;THIS IS FOR GENERAL INFOS
#define Gravity 	00 ;WARNING NOW USELESS, we specify in states what speed they add to the current speed anyway
#define Floa            01 
#define Traction        02 
#define MaxJumps        03 
#define MaxHspeed       04 
#define GroundState     06 
#define AirState        08 
#define DashState       10 
#define JumpState       12 
#define AirJumpState    14 
#define LandState       16 
#define BGN   		18  ;B attack Ground None
#define BGLR  		20  ;B attack Ground Left/Right
#define BGD   		22  ;B attack Ground Down
#define BGU   		24  ;B attack Ground Up
#define BAN   		26  ;B attack Air None
#define BALR  		28  ;B attack Air Left/Right
#define BAD   		30  ;B attack Air Down
#define BAU   		32  ;B attack Air Up
#define DashAttack      34 
#define SideSmash       36 
#define DownSmash       38 
#define UpSmash         40 
#define NeutralAir      42 
#define FrontAir        44 
#define BackAir         46 
#define DownAir         48 
#define UpAir           50 
#define LedgeState      52 

;THIS IS FOR STATE INFOS
#define StateSprite   00 
#define StateTeleport 04 
#define StateFlags    06 
#define StateDirX     07 
#define StateDirY     09 
#define KeysInfluence 11 
#define DefaultNext   12 
#define ToParse       14 

;THIS IS FOR STATEFLAGS
#define Inv		%10000000 
#define Piv		%01000000 
#define AbsX		%00100000 
#define AbsY		%00010000 
#define SetKnockBack	%00001000 
#define Type  		%00000111 ;Now we are studying this state's type
#define GroundNull	%00000000 ;on ground, doesn't allow moves (jump and attacks)
#define GroundOK	%00000001 ;on ground, allows moves
#define GroundDash	%00000010 ;on ground, allows dash moves
#define AirNull		%00000011 ;in air, doesn't allow aerial moves
#define AirOK		%00000100 ;in air, allows aerial moves
#define Aerial		%00000101 ;in aerial attack (useful to L-cancel)
#define Ledge		%00000110

;THIS IS FOR KEYS
#define MLeft		%10000000
#define Backward	MLeft
#define MRight		%01000000
#define Forward		MRight
#define MDown		%00100000
#define MUp		%00010000
#define MKeyFlag	%00001000
#define MNone		%00001000
;touches qu'on peut détecter en même temps
#define MA		%00001001
#define MLR		%00001010
;on peut encore mettre une touche ici
;touches qui se detectent toutes seules (ça ne veut rien dire)
#define MQuit	%00000000
#define MClear	MQuit
#define MJump	%00000001
#define MStart	%00000010
#define MPause MStart
#define MCLeft	%00000011
#define MCRight	%00000100
#define MCDown	%00000101
#define MCUp	%00000110
#define MB	%00000111

;COMMANDS
#define IJX       %01100000
#define IJNX      %01000000
#define REPEAT    %00100000
#define SETCHRONO %00010000
#define ONGROUND  %00000100
#define HITBOX    %00000101
#define HIT       %00000110
#define ONEDGE    %00000111
#define DJZ       %00000011
#define DJNZ      %00000010
#define ONKEY     %00000001

;THIS IS FOR HITBOXES
#define BoxFlags 00
  #define SetKnockback  %10000000
  #define Pivot         %01000000
  #define SetAlreadyHit %00100000
  #define NbBoxes       %00011111
#define Radius     01
#define NextPState 02
#define NextAState 04
#define NextAPosX  06
#define NextAPosY  07
#define HitStun    08
#define Damages    09
#define ProjDir    10
#define ProjAngle  11
#define ProjSpeed  12
#define List       14

;THIS IS FOR PLAYER'S DIRECTION
;0->->°DirLeft
;2->->°DirRight
;
;;CHARACTERS' ATTRIBUTES
;;WARNING attention aux 2 ou 3 octets voire pire !!
;L1+00->->°PInput
;L1+01->->°State
;L1+03->->°OldPY
;L1+05->->°OldPX
;L1+07->->°PY
;L1+09->->°PX
;L1+11->->°VY
;L1+13->->°VX
;L1+15->->°Character
;L1+17->->°Direction ;vaut 0 ou 2 pour faire -1 et avoir -1 ou 1
;L1+18->->°Repeat
;L1+19->->°Jumps ;vaut généralement 0 ou 1 ou 2 mais pour Rondoudou peut valoir plus; à 0 on ne peut plus sauter
;L1+20->->°TimerDJIJ
;L1+21->->°OnTheGround
;L1+22->->°AlreadyHit
;;;
;L1+23->->°TLeft
;L1+24->->°TRight
;L1+25->->°TDown
;L1+26->->°TUp
;;;
;L1+27->->°TA
;L1+28->->°TLR
;;;
;L1+29->->°TQuit
;L1+30->->°TJump
;L1+31->->°TStart->->°TPause
;L1+32->->°TCLeft
;L1+33->->°TCRight
;L1+34->->°TCDown
;L1+35->->°TCUp
;L1+36->->°TB
;37->->°NbAttributes
;;WARNING attention aux 2 ou 3 octets voire pire !!
;
;;VARIABLES
;L2+00->->°MiddleListCur
;L2+02->->°DX
;L2+04->->°DY
;L2+06->->°MDX
;L2+08->->°MDY
;L2+10->->°FrameSkip
;L2+12->->°KeepParsing
;L2+14->->°Map
;L2+16->->°DMap
;L2+18->->°VCharacter
;L2+20->->°InputRoutine
;L2+22->->°InputInit
;
;L5->->°MiddleList

#define MapSprite %10000000 
  #define MapRectangle 0
#define LeftLedge  %01000000
#define RightLedge %00100000

